diff --git a/pgAgent.cpp b/pgAgent.cpp
index c5e00fb..afee2df 100644
--- a/pgAgent.cpp
+++ b/pgAgent.cpp
@@ -11,22 +11,25 @@
 
 #include "pgAgent.h"
 
-#ifndef __WXMSW__
+#if !BOOST_OS_WINDOWS
 #include <unistd.h>
 #endif
 
-wxString connectString;
-wxString serviceDBname;
-wxString backendPid;
+std::wstring connectString;
+std::wstring serviceDBname;
+std::wstring backendPid;
 long longWait = 30;
 long shortWait = 5;
 long minLogLevel = LOG_ERROR;
 
+using namespace std;
+
 #define MAXATTEMPTS 10
 
-#ifndef __WXMSW__
+#if !BOOST_OS_WINDOWS
 bool runInForeground = false;
-wxString logFile = wxEmptyString;
+std::wstring logFile = L"";
+
 #else
 //pgAgent Initialized
 void Initialized();
@@ -38,28 +41,28 @@ int MainRestartLoop(DBconn *serviceConn)
 
 	int rc;
 
-	LogMessage(_("Clearing zombies"), LOG_DEBUG);
-	rc = serviceConn->ExecuteVoid(wxT("CREATE TEMP TABLE pga_tmp_zombies(jagpid int4)"));
+	LogMessage(L"Clearing zombies", LOG_DEBUG);
+	rc = serviceConn->ExecuteVoid(L"CREATE TEMP TABLE pga_tmp_zombies(jagpid int4)");
 
 	if (serviceConn->BackendMinimumVersion(9, 2))
 	{
 		rc = serviceConn->ExecuteVoid(
-		         wxT("INSERT INTO pga_tmp_zombies (jagpid) ")
-		         wxT("SELECT jagpid ")
-		         wxT("  FROM pgagent.pga_jobagent AG ")
-		         wxT("  LEFT JOIN pg_stat_activity PA ON jagpid=pid ")
-		         wxT(" WHERE pid IS NULL")
-		     );
+			L"INSERT INTO pga_tmp_zombies (jagpid) "
+			L"SELECT jagpid "
+			L"  FROM pgagent.pga_jobagent AG "
+			L"  LEFT JOIN pg_stat_activity PA ON jagpid=pid "
+			L" WHERE pid IS NULL"
+			);
 	}
 	else
 	{
 		rc = serviceConn->ExecuteVoid(
-		         wxT("INSERT INTO pga_tmp_zombies (jagpid) ")
-		         wxT("SELECT jagpid ")
-		         wxT("  FROM pgagent.pga_jobagent AG ")
-		         wxT("  LEFT JOIN pg_stat_activity PA ON jagpid=procpid ")
-		         wxT(" WHERE procpid IS NULL")
-		     );
+			L"INSERT INTO pga_tmp_zombies (jagpid) "
+			L"SELECT jagpid "
+			L"  FROM pgagent.pga_jobagent AG "
+			L"  LEFT JOIN pg_stat_activity PA ON jagpid=procpid "
+			L" WHERE procpid IS NULL"
+			);
 	}
 
 	if (rc > 0)
@@ -67,30 +70,31 @@ int MainRestartLoop(DBconn *serviceConn)
 		// There are orphaned agent entries
 		// mark the jobs as aborted
 		rc = serviceConn->ExecuteVoid(
-		         wxT("UPDATE pgagent.pga_joblog SET jlgstatus='d' WHERE jlgid IN (")
-		         wxT("SELECT jlgid ")
-		         wxT("FROM pga_tmp_zombies z, pgagent.pga_job j, pgagent.pga_joblog l ")
-		         wxT("WHERE z.jagpid=j.jobagentid AND j.jobid = l.jlgjobid AND l.jlgstatus='r');\n")
-
-		         wxT("UPDATE pgagent.pga_jobsteplog SET jslstatus='d' WHERE jslid IN ( ")
-		         wxT("SELECT jslid ")
-		         wxT("FROM pga_tmp_zombies z, pgagent.pga_job j, pgagent.pga_joblog l, pgagent.pga_jobsteplog s ")
-		         wxT("WHERE z.jagpid=j.jobagentid AND j.jobid = l.jlgjobid AND l.jlgid = s.jsljlgid AND s.jslstatus='r');\n")
-
-		         wxT("UPDATE pgagent.pga_job SET jobagentid=NULL, jobnextrun=NULL ")
-		         wxT("  WHERE jobagentid IN (SELECT jagpid FROM pga_tmp_zombies);\n")
-
-		         wxT("DELETE FROM pgagent.pga_jobagent ")
-		         wxT("  WHERE jagpid IN (SELECT jagpid FROM pga_tmp_zombies);\n")
-		     );
+			L"UPDATE pgagent.pga_joblog SET jlgstatus='d' WHERE jlgid IN ("
+			L"SELECT jlgid "
+			L"FROM pga_tmp_zombies z, pgagent.pga_job j, pgagent.pga_joblog l "
+			L"WHERE z.jagpid=j.jobagentid AND j.jobid = l.jlgjobid AND l.jlgstatus='r');\n"
+
+			L"UPDATE pgagent.pga_jobsteplog SET jslstatus='d' WHERE jslid IN ( "
+			L"SELECT jslid "
+			L"FROM pga_tmp_zombies z, pgagent.pga_job j, pgagent.pga_joblog l, pgagent.pga_jobsteplog s "
+			L"WHERE z.jagpid=j.jobagentid AND j.jobid = l.jlgjobid AND l.jlgid = s.jsljlgid AND s.jslstatus='r');\n"
+
+			L"UPDATE pgagent.pga_job SET jobagentid=NULL, jobnextrun=NULL "
+			L"  WHERE jobagentid IN (SELECT jagpid FROM pga_tmp_zombies);\n"
+
+			L"DELETE FROM pgagent.pga_jobagent "
+			L"  WHERE jagpid IN (SELECT jagpid FROM pga_tmp_zombies);\n"
+			);
 	}
 
-	rc = serviceConn->ExecuteVoid(wxT("DROP TABLE pga_tmp_zombies"));
+	rc = serviceConn->ExecuteVoid(L"DROP TABLE pga_tmp_zombies");
 
-	wxString hostname = wxGetFullHostName();
+	std::string host_name = boost::asio::ip::host_name();
+	std::wstring hostname(host_name.begin(), host_name.end());
 
 	rc = serviceConn->ExecuteVoid(
-	         wxT("INSERT INTO pgagent.pga_jobagent (jagpid, jagstation) SELECT pg_backend_pid(), '") + hostname + wxT("'"));
+		L"INSERT INTO pgagent.pga_jobagent (jagpid, jagstation) SELECT pg_backend_pid(), '" + hostname + L"'");
 	if (rc < 0)
 		return rc;
 
@@ -98,56 +102,35 @@ int MainRestartLoop(DBconn *serviceConn)
 	{
 		bool foundJobToExecute = false;
 
-		LogMessage(_("Checking for jobs to run"), LOG_DEBUG);
-		DBresult *res = serviceConn->Execute(
-		                    wxT("SELECT J.jobid ")
-		                    wxT("  FROM pgagent.pga_job J ")
-		                    wxT(" WHERE jobenabled ")
-		                    wxT("   AND jobagentid IS NULL ")
-		                    wxT("   AND jobnextrun <= now() ")
-		                    wxT("   AND (jobhostagent = '' OR jobhostagent = '") + hostname + wxT("')")
-		                    wxT(" ORDER BY jobnextrun"));
+		LogMessage(L"Checking for jobs to run", LOG_DEBUG);
+		DBresultPtr res = serviceConn->Execute(
+			L"SELECT J.jobid "
+			L"  FROM pgagent.pga_job J "
+			L" WHERE jobenabled "
+			L"   AND jobagentid IS NULL "
+			L"   AND jobnextrun <= now() "
+			L"   AND (jobhostagent = '' OR jobhostagent = '" + hostname + L"')"
+			L" ORDER BY jobnextrun");
 
 		if (res)
 		{
-			while(res->HasData())
+			while (res->HasData())
 			{
-				wxString jobid = res->GetString(wxT("jobid"));
-
-				JobThread *jt = new JobThread(jobid);
-
-				if (jt->Runnable())
-				{
-					jt->Create();
-					jt->Run();
-					foundJobToExecute = true;
-				}
-				else
-				{
-					// Failed to launch the thread. Insert an entry with
-					// "internal error" status in the joblog table, to leave
-					// a trace of fact that we tried to launch the job.
-					DBresult *res = serviceConn->Execute(
-						wxT("INSERT INTO pgagent.pga_joblog(jlgid, jlgjobid, jlgstatus) ")
-						wxT("VALUES (nextval('pgagent.pga_joblog_jlgid_seq'), ") + jobid + wxT(", 'i')"));
-					if (res)
-						delete res;
-
-					// A thread object that's started will destroy itself when
-					// it's finished, but one that never starts we'll have to
-					// destory ourselves.
-					delete jt;
-				}
+				std::wstring jobid = res->GetString(L"jobid");
+
+				boost::thread job_thread = boost::thread(JobThread(jobid));
+				job_thread.detach();
+				foundJobToExecute = true;
 				res->MoveNext();
 			}
+			res = NULL;
 
-			delete res;
-			LogMessage(_("Sleeping..."), LOG_DEBUG);
+			LogMessage(L"Sleeping...", LOG_DEBUG);
 			WaitAWhile();
 		}
 		else
 		{
-			LogMessage(_("Failed to query jobs table!"), LOG_ERROR);
+			LogMessage(L"Failed to query jobs table!", LOG_ERROR);
 		}
 		if (!foundJobToExecute)
 			DBconn::ClearConnections();
@@ -163,7 +146,7 @@ void MainLoop()
 	// OK, let's get down to business
 	do
 	{
-		LogMessage(_("Creating primary connection"), LOG_DEBUG);
+		LogMessage(L"Creating primary connection", LOG_DEBUG);
 		DBconn *serviceConn = DBconn::InitConnection(connectString);
 
 		if (serviceConn && serviceConn->IsValid())
@@ -171,59 +154,54 @@ void MainLoop()
 			serviceDBname = serviceConn->GetDBname();
 
 			// Basic sanity check, and a chance to get the serviceConn's PID
-			LogMessage(_("Database sanity check"), LOG_DEBUG);
-			DBresult *res = serviceConn->Execute(wxT("SELECT count(*) As count, pg_backend_pid() AS pid FROM pg_class cl JOIN pg_namespace ns ON ns.oid=relnamespace WHERE relname='pga_job' AND nspname='pgagent'"));
+			LogMessage(L"Database sanity check", LOG_DEBUG);
+			DBresultPtr res = serviceConn->Execute(L"SELECT count(*) As count, pg_backend_pid() AS pid FROM pg_class cl JOIN pg_namespace ns ON ns.oid=relnamespace WHERE relname='pga_job' AND nspname='pgagent'");
 			if (res)
 			{
-				wxString val = res->GetString(wxT("count"));
+				std::wstring val = res->GetString(L"count");
 
-				if (val == wxT("0"))
-					LogMessage(_("Could not find the table 'pgagent.pga_job'. Have you run pgagent.sql on this database?"), LOG_ERROR);
+				if (val == L"0")
+					LogMessage(L"Could not find the table 'pgagent.pga_job'. Have you run pgagent.sql on this database?", LOG_ERROR);
 
-				backendPid = res->GetString(wxT("pid"));
+				backendPid = res->GetString(L"pid");
 
-				delete res;
 				res = NULL;
 			}
 
 			// Check for particular version
 
 			bool hasSchemaVerFunc = false;
-			wxString sqlCheckSchemaVersion
-			= wxT("SELECT COUNT(*)                                            ")\
-			  wxT("FROM pg_proc                                               ")\
-			  wxT("WHERE proname = 'pgagent_schema_version' AND               ")\
-			  wxT("      pronamespace = (SELECT oid                           ")\
-			  wxT("                      FROM pg_namespace                    ")\
-			  wxT("                      WHERE nspname = 'pgagent') AND       ")\
-			  wxT("      prorettype = (SELECT oid                             ")\
-			  wxT("                    FROM pg_type                           ")\
-			  wxT("                    WHERE typname = 'int2') AND            ")\
-			  wxT("      proargtypes = ''                                     ");
+			std::wstring sqlCheckSchemaVersion
+				= L"SELECT COUNT(*)                                            "\
+				L"FROM pg_proc                                               "\
+				L"WHERE proname = 'pgagent_schema_version' AND               "\
+				L"      pronamespace = (SELECT oid                           "\
+				L"                      FROM pg_namespace                    "\
+				L"                      WHERE nspname = 'pgagent') AND       "\
+				L"      prorettype = (SELECT oid                             "\
+				L"                    FROM pg_type                           "\
+				L"                    WHERE typname = 'int2') AND            "\
+				L"      proargtypes = ''                                     ";
 
 			res = serviceConn->Execute(sqlCheckSchemaVersion);
 
 			if (res)
 			{
-				if (res->IsValid() && res->GetString(0) == wxT("1"))
+				if (res->IsValid() && res->GetString(0) == L"1")
 					hasSchemaVerFunc = true;
-				delete res;
 				res = NULL;
 			}
 
 			if (!hasSchemaVerFunc)
 			{
-				LogMessage(_("Couldn't find the function 'pgagent_schema_version' - please run pgagent_upgrade.sql."), LOG_ERROR);
+				LogMessage(L"Couldn't find the function 'pgagent_schema_version' - please run pgagent_upgrade.sql.", LOG_ERROR);
 			}
 
-			wxString strPgAgentSchemaVer = serviceConn->ExecuteScalar(wxT("SELECT pgagent.pgagent_schema_version()"));
-			wxString currentPgAgentVersion;
-			currentPgAgentVersion.Printf(_("%d"), PGAGENT_VERSION_MAJOR);
+			std::wstring strPgAgentSchemaVer = serviceConn->ExecuteScalar(L"SELECT pgagent.pgagent_schema_version()");
+			std::wstring currentPgAgentVersion = (boost::wformat(L"%d") % PGAGENT_VERSION_MAJOR).str();
 			if (strPgAgentSchemaVer != currentPgAgentVersion)
 			{
-				wxString strSchemaVerMisMatch;
-				strSchemaVerMisMatch.Printf(_("Unsupported schema version: %s. Version %s is required - please run pgagent_upgrade.sql."), strPgAgentSchemaVer.c_str(), currentPgAgentVersion.c_str());
-				LogMessage(strSchemaVerMisMatch, LOG_ERROR);
+				LogMessage((L"Unsupported schema version: " + strPgAgentSchemaVer + L". Version " + currentPgAgentVersion + L" is required - please run pgagent_upgrade.sql."), LOG_ERROR);
 			}
 
 #ifdef WIN32
@@ -232,16 +210,16 @@ void MainLoop()
 			MainRestartLoop(serviceConn);
 		}
 
-		LogMessage(wxString::Format(_("Couldn't create the primary connection (attempt %d): %s"), attemptCount, serviceConn->GetLastError().c_str()), LOG_STARTUP);
+		LogMessage((boost::wformat(L"Couldn't create the primary connection (attempt %d): %s") % attemptCount % serviceConn->GetLastError()).str(), LOG_STARTUP);
+
 		DBconn::ClearConnections(true);
 
 		// Try establishing primary connection upto MAXATTEMPTS times
 		if (attemptCount++ >= (int)MAXATTEMPTS)
 		{
-			LogMessage(wxString::Format(_("Stopping pgAgent: Couldn't establish the primary connection with the database server.")), LOG_ERROR);
+			LogMessage(L"Stopping pgAgent: Couldn't establish the primary connection with the database server.", LOG_ERROR);
 		}
 		WaitAWhile();
-	}
-	while (1);
+	} while (1);
 }
 
diff --git a/unix.cpp b/unix.cpp
index 27febd3..7098e9b 100644
--- a/unix.cpp
+++ b/unix.cpp
@@ -14,86 +14,119 @@
 // *nix only!!
 #ifndef WIN32
 
-#include <wx/filename.h>
-#include <wx/ffile.h>
+#include <iostream>
 #include <fcntl.h>
+#include <fstream>
+
+using namespace std;
+
 void printVersion();
 
-void usage(const wxString &executable)
+void usage(const std::wstring &executable)
 {
-	wxFileName *fn = new wxFileName(executable);
+	char *appName = WStringToChar(executable);
 	printVersion();
 
-	wxPrintf(_("Usage:\n"));
-	wxPrintf(fn->GetName() + _(" [options] <connect-string>\n"));
-	wxPrintf(_("options:\n"));
-	wxPrintf(_("-v (display version info and then exit)\n"));
-	wxPrintf(_("-f run in the foreground (do not detach from the terminal)\n"));
-	wxPrintf(_("-t <poll time interval in seconds (default 10)>\n"));
-	wxPrintf(_("-r <retry period after connection abort in seconds (>=10, default 30)>\n"));
-	wxPrintf(_("-s <log file (messages are logged to STDOUT if not specified>\n"));
-	wxPrintf(_("-l <logging verbosity (ERROR=0, WARNING=1, DEBUG=2, default 0)>\n"));
+	fprintf(stdout, "Usage:\n");
+	fprintf(stdout, "%s [options] <connect-string>\n", appName);
+	fprintf(stdout, "options:\n");
+	fprintf(stdout, "-v (display version info and then exit)\n");
+	fprintf(stdout, "-f run in the foreground (do not detach from the terminal)\n");
+	fprintf(stdout, "-t <poll time interval in seconds (default 10)>\n");
+	fprintf(stdout, "-r <retry period after connection abort in seconds (>=10, default 30)>\n");
+	fprintf(stdout, "-s <log file (messages are logged to STDOUT if not specified>\n");
+	fprintf(stdout, "-l <logging verbosity (ERROR=0, WARNING=1, DEBUG=2, default 0)>\n");
+
+	if (appName)
+		delete []appName;
 }
 
-void LogMessage(wxString msg, int level)
+void LogMessage(const std::wstring &msg, const int &level)
 {
-	wxFFile file;
-	if (logFile.IsEmpty())
+	std::wofstream out;
+	bool writeToStdOut = false;
+
+	if (!logFile.empty())
 	{
-		file.Attach(stdout);
+		std::string log_file(logFile.begin(), logFile.end());
+		out.open((const char *)log_file.c_str(), ios::out | ios::app);
+		if (!out.is_open())
+		{
+			fprintf(stderr, "Can not open the logfile!");
+			return;
+		}
 	}
 	else
-	{
-		file.Open(logFile.c_str(), wxT("a"));
-	}
+		writeToStdOut = true;
 
-	if (!file.IsOpened())
-	{
-		wxFprintf(stderr, _("Can not open the logfile!"));
-		return;
-	}
+	boost::gregorian::date current_date(boost::gregorian::day_clock::local_day());
 
-	wxDateTime logTime = wxDateTime::Now();
-	wxString logTimeString = logTime.Format() + wxT(" : ");
+	std::wstring day_week = boost::lexical_cast<std::wstring>(current_date.day_of_week());
+	std::wstring year = boost::lexical_cast<std::wstring>(current_date.year());
+	std::wstring month = boost::lexical_cast<std::wstring>(current_date.month());
+	std::wstring day = boost::lexical_cast<std::wstring>(current_date.day());
+
+	boost::posix_time::ptime pt = boost::posix_time::second_clock::local_time();
+	std::wstring time_day = boost::lexical_cast<std::wstring>(pt.time_of_day());
+
+	std::wstring logTimeString = L"";
+	logTimeString = day_week + L" " + month + L" " + day + L" " + time_day + L" " + year + L" ";
 
 	switch (level)
 	{
 		case LOG_DEBUG:
 			if (minLogLevel >= LOG_DEBUG)
-				file.Write(logTimeString + _("DEBUG: ") + msg + wxT("\n"));
+			{
+				logTimeString = logTimeString + L"DEBUG: " + msg + L"\n";
+				if (writeToStdOut)
+					std::wcout << logTimeString;
+				else
+					out.write(logTimeString.c_str(), logTimeString.size());
+			}
 			break;
 		case LOG_WARNING:
 			if (minLogLevel >= LOG_WARNING)
-				file.Write(logTimeString + _("WARNING: ") + msg + wxT("\n"));
+			{
+				logTimeString = logTimeString + L"WARNING: " + msg + L"\n";
+				if (writeToStdOut)
+					std::wcout << logTimeString;
+				else
+					out.write(logTimeString.c_str(), logTimeString.size());
+			}
 			break;
 		case LOG_ERROR:
-			file.Write(logTimeString + _("ERROR: ") + msg + wxT("\n"));
+			logTimeString = logTimeString + L"ERROR: " + msg + L"\n";
+			if (writeToStdOut)
+				std::wcout << logTimeString;
+			else
+				out.write(logTimeString.c_str(), logTimeString.size());
 			exit(1);
 			break;
 		case LOG_STARTUP:
-			file.Write(logTimeString + _("WARNING: ") + msg + wxT("\n"));
+			logTimeString = logTimeString + L"WARNING: " + msg + L"\n";
+			if (writeToStdOut)
+				std::wcout << logTimeString;
+			else
+				out.write(logTimeString.c_str(), logTimeString.size());
 			break;
 	}
 
-	if (logFile.IsEmpty())
+	if (!logFile.empty())
 	{
-		file.Detach();
-	}
-	else
-	{
-		file.Close();
+		out.close();
 	}
 }
 
+
 // Shamelessly lifted from pg_autovacuum...
 static void daemonize(void)
 {
 	pid_t pid;
 
 	pid = fork();
-	if (pid == (pid_t) - 1)
+	if (pid == (pid_t)-1)
 	{
-		LogMessage(_("Cannot disassociate from controlling TTY"), LOG_ERROR);
+		LogMessage(L"Cannot disassociate from controlling TTY", LOG_ERROR);
 		exit(1);
 	}
 	else if (pid)
@@ -102,7 +135,7 @@ static void daemonize(void)
 #ifdef HAVE_SETSID
 	if (setsid() < 0)
 	{
-		LogMessage(_("Cannot disassociate from controlling TTY"), LOG_ERROR);
+		LogMessage(L"Cannot disassociate from controlling TTY", LOG_ERROR);
 		exit(1);
 	}
 #endif
@@ -111,11 +144,8 @@ static void daemonize(void)
 
 int main(int argc, char **argv)
 {
-	// Statup wx
-	wxInitialize();
-
-	wxString executable;
-	executable = wxString::FromAscii(argv[0]);
+	std::wstring executable;
+	executable.assign(CharToWString(argv[0]));
 
 	if (argc < 2)
 	{
